CREATE TABLE "Catalogo" (
    "F" text NOT NULL,
    "P" text NOT NULL,
    "Costo" numeric
);


ALTER TABLE "Catalogo" OWNER TO postgres;


CREATE TABLE "Fornitori" (
    "CF" text NOT NULL,
    "Nome" text,
    "Indirizzo" text,
    "Città" text
);


ALTER TABLE "Fornitori" OWNER TO postgres;


CREATE TABLE "Prodotti" (
    "CP" text NOT NULL,
    "Nome" text,
    "Marca" text,
    "Modello" text
);


ALTER TABLE "Prodotti" OWNER TO postgres;


INSERT INTO "Catalogo" VALUES ('001', '0002', 3200);
INSERT INTO "Catalogo" VALUES ('001', '0003', 2200);
INSERT INTO "Catalogo" VALUES ('002', '0001', 1900);
INSERT INTO "Catalogo" VALUES ('002', '0002', 2500);
INSERT INTO "Catalogo" VALUES ('002', '0003', 1800);
INSERT INTO "Catalogo" VALUES ('010', '0001', 2200);
INSERT INTO "Catalogo" VALUES ('010', '0003', 2000);

INSERT INTO "Fornitori" VALUES ('001', 'Ladroni', 'via Ostiense', 'Roma');
INSERT INTO "Fornitori" VALUES ('002', 'Risparmietti', 'viale Marconi', 'Roma');
INSERT INTO "Fornitori" VALUES ('010', 'Teloporto', 'via Roma', 'Milano');

INSERT INTO "Prodotti" VALUES ('0001', 'Notebook', 'IBM', '390 x');
INSERT INTO "Prodotti" VALUES ('0002', 'Desktop', 'IBM', '510');
INSERT INTO "Prodotti" VALUES ('0003', 'Desktop', 'ACER', '730');

ALTER TABLE ONLY "Catalogo"
    ADD CONSTRAINT "Catalogo_pkey" PRIMARY KEY ("F", "P");


ALTER TABLE ONLY "Fornitori"
    ADD CONSTRAINT "Fornitori_pkey" PRIMARY KEY ("CF");


ALTER TABLE ONLY "Prodotti"
    ADD CONSTRAINT "Prodotti_pkey" PRIMARY KEY ("CP");


ALTER TABLE ONLY "Catalogo"
    ADD CONSTRAINT "Catalogo_F_fkey" FOREIGN KEY ("F") REFERENCES "Fornitori"("CF");


ALTER TABLE ONLY "Catalogo"
    ADD CONSTRAINT "Catalogo_P_fkey" FOREIGN KEY ("P") REFERENCES "Prodotti"("CP");