﻿-- esercizio 1

select distinct P."Nome", P."Marca", P."Modello"
from
"prodotti_fornitori"."Catalogo" C,
"prodotti_fornitori"."Prodotti" P
where 
C."P" = P."CP"
and C."Costo" < 2000;

-- esercizio 2

select distinct F."Nome"
from
"prodotti_fornitori"."Catalogo" C,
"prodotti_fornitori"."Prodotti" P,
"prodotti_fornitori"."Fornitori" F
where 
C."P" = P."CP"
and C."F" = F."CF"
and P."Marca" = 'IBM';

-- esercizio 3

-- variante con self join
select distinct C1."P"
from
"prodotti_fornitori"."Catalogo" C1,
"prodotti_fornitori"."Catalogo" C2
where 
C1."P" = C2."P"
and C1."F" <> C2."F";

-- variante con aggregazione e having
select distinct C."P"
from "prodotti_fornitori"."Catalogo" C
group by C."P"
having count(*) > 1;

-- variante con aggregazione e nidificazione
select distinct C."P"
from "prodotti_fornitori"."Catalogo" C
where 1<all (select count(*)
from "prodotti_fornitori"."Catalogo" C2
where C2."P" = C."P");

-- esercizio 4

-- variante con vista e differenze
create or replace view "prodotti_fornitori"."forniture_mancate" as 
select C1."P", C2."F"
from 
"prodotti_fornitori"."Catalogo" C1,
"prodotti_fornitori"."Catalogo" C2
except
select C."P", C."F"
from "prodotti_fornitori"."Catalogo" C;

select C."F" -- notare che non c'e' il distinct
from "prodotti_fornitori"."Catalogo" C
except
select FM."F"
from "prodotti_fornitori"."forniture_mancate" FM;

-- variante con vista e NOT EXISTS nidificato
create or replace view "prodotti_fornitori"."forniture_mancate" as 
select C1."P", C2."F"
from 
"prodotti_fornitori"."Catalogo" C1,
"prodotti_fornitori"."Catalogo" C2
except
select C."P", C."F"
from "prodotti_fornitori"."Catalogo" C;

select distinct C."F" -- notare il distinct
from "prodotti_fornitori"."Catalogo" C
where not exists ( -- tutti i fornitori per cui non esiste nessuna fornitura mancata
	select FM."P"
	from "prodotti_fornitori"."forniture_mancate" FM
	where 
	FM."F" = C."F" -- per il fornitore stesso
);

-- variante con doppio NOT EXISTS, senza vista
select distinct C."F" -- tutti i fornitori
from "prodotti_fornitori"."Catalogo" C
where not exists ( -- per cui non esistono prodotti
	select C1."P"
	from "prodotti_fornitori"."Catalogo" C1
	where not exists ( -- che non sono forniti dal fornitore stesso
		select * 
		from "prodotti_fornitori"."Catalogo" C2
		where C2."P" = C1."P"
		and C2."F" = C."F"
	)
);

-- esercizio 5

-- variante con viste ed EXCEPT
create or replace view "prodotti_fornitori"."forniture_mancate_IBM" as 
select C1."P", C2."F"
from 
"prodotti_fornitori"."Catalogo" C1,
"prodotti_fornitori"."Catalogo" C2,
"prodotti_fornitori"."Prodotti" P
where 
C1."P" = P."CP"
and P."Marca" = 'IBM'
except
select C."P", C."F"
from "prodotti_fornitori"."Catalogo" C;

select F."Nome" -- notare che non c'e' il distinct
from "prodotti_fornitori"."Catalogo" C,
"prodotti_fornitori"."Fornitori" F
where C."F" = F."CF"
except
select F."Nome"
from "prodotti_fornitori"."forniture_mancate_IBM" FM,
"prodotti_fornitori"."Fornitori" F
where FM."F" = F."CF";

-- variante senza viste e con NOT EXISTS
select distinct F."Nome" -- tutti i fornitori
from "prodotti_fornitori"."Catalogo" C,
"prodotti_fornitori"."Fornitori" F
where
C."F" = F."CF"
and not exists ( -- per cui non esistono prodotti (IBM)
	select C1."P"
	from "prodotti_fornitori"."Catalogo" C1,
	"prodotti_fornitori"."Prodotti" P
	where C1."P" = P."CP"
	and P."Marca"='IBM'
	and not exists ( -- che non sono forniti dal fornitore stesso
		select * 
		from "prodotti_fornitori"."Catalogo" C2
		where C2."P" = C1."P"
		and C2."F" = C."F"
	)
);

-- esercizio 6

select F."Città", avg(C."Costo") as "Costo medio"
from 
"prodotti_fornitori"."Catalogo" C,
"prodotti_fornitori"."Fornitori" F
where 
C."F" = F."CF"
group by F."Città";


-- esercizio 7

select P."CP", P."Nome", C."Costo"
from
"prodotti_fornitori"."Catalogo" C,
"prodotti_fornitori"."Prodotti" P
where C."P" = P."CP"
and C."Costo" >= (
	select max(C."Costo")
	from "prodotti_fornitori"."Catalogo" C
);

-- esercizio 8

select F."Nome", avg(C."Costo") as "Costo medio"
from 
"prodotti_fornitori"."Catalogo" C,
"prodotti_fornitori"."Fornitori" F
where
C."F" = F."CF"
group by F."Nome"
having avg(C."Costo")>=all(
	select avg(C1."Costo") as "Costo medio" -- costo medio per Fornitore
	from 
	"prodotti_fornitori"."Catalogo" C1,
	"prodotti_fornitori"."Fornitori" F1
	where 
	C1."F" = F1."CF"
	group by C1."F"
);

-- esecizio 9

select C."P", min(C."Costo") as "Costo Minimo"
from
"prodotti_fornitori"."Catalogo" C
group by C."P";

-- esercizio 10

create or replace view "prodotti_fornitori"."prodotti_costi_massimi" as
select C."P", max(C."Costo") as "Costo Massimo"
from "prodotti_fornitori"."Catalogo" C
group by C."P";

select P."Nome" as "Nome prodotto", F."Nome" as "Nome fornitore", C."Costo"
from
"prodotti_fornitori"."Catalogo" C,
"prodotti_fornitori"."prodotti_costi_massimi" CM,
"prodotti_fornitori"."Fornitori" F,
"prodotti_fornitori"."Prodotti" P
where
C."P" = CM."P"
and F."CF" = C."F"
and P."CP" = C."P"
and C."Costo" = CM."Costo Massimo";

-- esercizio 11

select C1."P"
from
"prodotti_fornitori"."Catalogo" C1,
"prodotti_fornitori"."Catalogo" C2,
"prodotti_fornitori"."Fornitori" F1,
"prodotti_fornitori"."Fornitori" F2
where
    C1."F" = F1."CF"
and C2."F" = F2."CF"
and F1."Nome" = 'Ladroni'
and F2."Nome" = 'Risparmietti'
and C1."P" = C2."P"
and C1."Costo">C2."Costo";


-- esercizio 12

select distinct F."CF", F."Nome" 
from
"prodotti_fornitori"."Fornitori" F,
"prodotti_fornitori"."Prodotti" P,
"prodotti_fornitori"."Catalogo" C
where F."CF" = C."F"
and P."CP" = C."P"
and (P."Nome" = 'Notebook' 
	or
    P."Nome" = 'Desktop');

-- esercizio 13

select F."Nome", count(*) as "Numero modelli"
from
"prodotti_fornitori"."Catalogo" C,
"prodotti_fornitori"."Prodotti" P,
"prodotti_fornitori"."Fornitori" F
where C."P" = P."CP"
and C."F" = F."CF"
and P."Nome" = 'Desktop'
group by F."Nome";

-- esercizio 14

create or replace view "prodotti_fornitori"."numero_articoli_1.9k-2k" as
select C."F", count(*) as "NumeroArticoli"
from "prodotti_fornitori"."Catalogo" C
where C."Costo" between 1500 and 2000 -- oppure con le condizioni >= and <=
group by C."F";

select F."Nome"
from "prodotti_fornitori"."numero_articoli_1.9k-2k" PF,
"prodotti_fornitori"."Fornitori" F
where PF."NumeroArticoli">=
(select max("NumeroArticoli")
from "prodotti_fornitori"."numero_articoli_1.9k-2k"
)
and F."CF" = PF."F";